library communication_handler;

import 'dart:convert' as convert;
import 'dart:convert';
import 'dart:io';
import 'package:http/http.dart' as http;

class Communication {
  OnCommunicationLitsrer listener;

  Communication(this.listener);

  Post(String url, Map<String, String> param, Object object) async {
    var request = new http.Request("POST", Uri.parse(url));
    request.bodyFields = param;
    request.headers.addAll({'api-key': 'WLJGDnxq9u5bvYjzurmo1N2q8ljDki84'});

    request
        .send()
        .then((response) => response.stream
        .bytesToString()
        .then((value) => listener.onCallBackSuccess(value)))
        .catchError((error) => listener.onCallBackFail(error));
  }

  Get(String url, Map<String, dynamic> param, Object object) async {
    var request = new http.Request("GET", Uri.parse(url));
    request.bodyFields = param;
    request.headers.addAll({'api-key': 'WLJGDnxq9u5bvYjzurmo1N2q8ljDki84'});
    request
        .send()
        .then((response) => response.stream
        .bytesToString()
        .then((value) => listener.onCallBackSuccess(value)))
        .catchError((error) => listener.onCallBackFail(error));
  }

/*
  Read(String url,Object object) async {
    var request = new http.MultipartRequest("POST", Uri.parse(url));
    request.fields.addAll(param);
    request.headers.addAll( {'api-key':'WLJGDnxq9u5bvYjzurmo1N2q8ljDki84'});
    request.files.add(new http.MultipartFile.fromBytes('file', await file.readAsBytes()));
    request.send().then((response) {
      if (response.statusCode == 200) {
        listener.onCallBackSuccess(response.toString());
      }
    }).catchError((error, stackTrace) {
      print("inner: $error");
      listener.onCallBackFail(error.toString());

    });
  }*/

  Part(String url, Map<String, dynamic> param, File file, Object object) async {
    var request = new http.MultipartRequest("POST", Uri.parse(url));
    request.fields.addAll(param);
    request.headers.addAll({'api-key': 'WLJGDnxq9u5bvYjzurmo1N2q8ljDki84'});
    request.files.add(
        new http.MultipartFile.fromBytes('file', await file.readAsBytes()));
    request.send().then((response) {
      if (response.statusCode == 200) {
        listener.onCallBackSuccess(response.toString());
      }
    }).catchError((error, stackTrace) {
      print("inner: $error");
      listener.onCallBackFail(error.toString());
    });
  }

  PartList(String url, Map<String, dynamic> param, String key,
      List<File> fileList, Object object) async {
    var request = new http.MultipartRequest("POST", Uri.parse(url));
    request.fields.addAll(param);
    var i = 0;
    for (File file in fileList) {
      request.files.add(new http.MultipartFile.fromBytes(
          key + '[${i}]', await file.readAsBytes()));
    }
    request.send().then((response) {
      if (response.statusCode == 200) {
        listener.onCallBackSuccess(response.toString());
      }
    }).catchError((error, stackTrace) {
      print("inner: $error");
      listener.onCallBackFail(error.toString());
    });
  }
}

abstract class OnCommunicationLitsrer {
  void onCallBackSuccess(String response);
  void onCallBackFail(String error);
}
